Public Class txtImport

    Private clsFileAndPath As String
    Private clsCrossRefParentIndex As Integer
    Private clsCrossRefChildIndex As Integer
    Private clsCrossRefTableName As String
    Private clsCrossRefTableFillCmd As String
    Private clsCrossRefTableConString As String
    Private clsImportedDataSet As New DataSet()
    Private myDataSet As New DataSet()
    Private clsImportProgress As Double
    Private clsTotalRows As Long

    Public Event ImportProgress()

    Public ReadOnly Property TotalRows()
        Get
            Return clsTotalRows
        End Get
    End Property

    Public ReadOnly Property GetImportProgress()
        Get
            Return clsImportProgress
        End Get
    End Property

    Public Property FileAndPath()
        Get
            Return clsFileAndPath
        End Get
        Set(ByVal Value)
            clsFileAndPath = Value
        End Set
    End Property

    Public Property CrossRefParentField()
        Get
            Return clsCrossRefParentIndex
        End Get
        Set(ByVal Value)
            clsCrossRefParentIndex = Value
        End Set
    End Property

    Public Property CrossRefChildField()
        Get
            Return clsCrossRefChildIndex
        End Get
        Set(ByVal Value)
            clsCrossRefChildIndex = Value
        End Set
    End Property

    Public Property CrossRefTableName()
        Get
            Return clsCrossRefTableName
        End Get
        Set(ByVal Value)
            clsCrossRefTableName = Value
        End Set
    End Property

    Public Property CrossRefTableFillCommand()
        Get
            Return clsCrossRefTableFillCmd
        End Get
        Set(ByVal Value)
            clsCrossRefTableFillCmd = Value
        End Set
    End Property

    Public Property CrossRefTableConString()
        Get
            Return clsCrossRefTableConString
        End Get
        Set(ByVal Value)
            clsCrossRefTableConString = Value
        End Set
    End Property

    Public ReadOnly Property ImportedDataSet() As DataSet
        Get
            Return clsImportedDataSet
        End Get
    End Property

    Public Sub DeleteTable(ByVal TableName As String)

        myDataSet.Tables.Remove(TableName)

    End Sub

    Private Function GetTotalRows() As Long

        Dim myReader As New System.IO.StreamReader(clsFileAndPath)

        Do While myReader.Peek <> -1
            myReader.ReadLine()
            GetTotalRows = GetTotalRows + 1
        Loop

    End Function

    ReadOnly Property FileName()
        Get
            Do Until clsFileAndPath.IndexOf("\") = -1
                clsFileAndPath = Mid(clsFileAndPath, Len(Left(clsFileAndPath, clsFileAndPath.IndexOf("\") + 1)) + 1)
            Loop
            Return Left(clsFileAndPath, clsFileAndPath.IndexOf("."))
        End Get
    End Property

    Public Sub ExecutImport()

        Dim myReader As New System.IO.StreamReader(clsFileAndPath)
        Dim CurrentLine As String
        Dim IsFirstLine As Boolean
        Dim myTable As New DataTable()
        Dim SqlTable As New DataTable()
        Dim ColumnName As String
        Dim tmpCount As Integer
        Dim ColumnCount As Integer
        Dim myColumn As DataColumn
        Dim myRowSql As DataRow
        Dim myRowTable As DataRow
        Dim IsValidRow As Boolean
        Dim ColumnIsDouble As Boolean
        Dim UnknownCount As Integer
        Dim RowCount As Integer
        Dim tmpImportProgress As Double
        Dim ImportFileName As String

        clsTotalRows = GetTotalRows()

        If clsCrossRefTableName <> "" Then
            Dim myConnection As New SqlClient.SqlConnection(clsCrossRefTableConString)
            Dim myCommand As New SqlClient.SqlCommand(clsCrossRefTableFillCmd)
            Dim daCRT As New SqlClient.SqlDataAdapter(myCommand)
            myCommand.Connection = myConnection
            SqlTable = New DataTable(clsCrossRefTableName)
            myDataSet.Tables.Add(clsCrossRefTableName)
            daCRT.Fill(myDataSet.Tables(clsCrossRefTableName))
        End If

        ImportFileName = FileName

        myTable = New DataTable(ImportFileName)
        myDataSet.Tables.Add(ImportFileName)

        While myReader.Peek <> -1
            Try
                CurrentLine = myReader.ReadLine
                If IsFirstLine = False Then
                    While CurrentLine.IndexOf(",") > 0
                        ColumnName = Microsoft.VisualBasic.Left(CurrentLine, CurrentLine.IndexOf(","))
                        For Each myColumn In myDataSet.Tables(ImportFileName).Columns
                            If ColumnName = CStr(myDataSet.Tables(ImportFileName).Columns(ColumnCount).ToString) Then
                                ColumnIsDouble = True
                            End If
                            ColumnCount += 1
                        Next
                        ColumnCount = 0
                        If ColumnIsDouble = True Then
                            ColumnIsDouble = False
                            myColumn = New DataColumn(ColumnName & tmpCount)
                            tmpCount += 1
                        Else
                            myColumn = New DataColumn(ColumnName)
                        End If
                        myDataSet.Tables(ImportFileName).Columns.Add(myColumn)
                        CurrentLine = Mid(CurrentLine, Len(ColumnName) + 3)
                    End While
                    myColumn = New DataColumn(CurrentLine & tmpCount + 1)
                    myDataSet.Tables(ImportFileName).Columns.Add(myColumn)
                End If
                If IsFirstLine = False Then
                    IsFirstLine = True
                    tmpCount = 0
                Else
                    myDataSet.Tables(ImportFileName).Rows.Add(CurrentLine.Split(","c))
                    myRowTable = myDataSet.Tables(ImportFileName).Rows(RowCount)
                    RowCount += 1
                    If clsCrossRefTableName <> "" Then
                        For Each myRowSql In myDataSet.Tables(clsCrossRefTableName).Rows
                            If CStr(myRowSql(clsCrossRefParentIndex)) = CStr(myRowTable(clsCrossRefChildIndex)) Then
                                IsValidRow = True
                            End If
                        Next
                        If IsValidRow = True Then
                            IsValidRow = False
                        Else
                            RowCount -= 1
                            myDataSet.Tables(ImportFileName).Rows(RowCount).Delete()
                        End If
                    End If
                End If
            Catch e As Exception
                Select Case Err.Number
                    Case 5
                        UnknownCount += 1
                        myColumn = New DataColumn("Unknown" & UnknownCount)
                        myDataSet.Tables(ImportFileName).Columns.Add(myColumn)
                    Case Else
                        MsgBox(Err.Number & "  " & Err.Description)
                End Select
            End Try
            tmpImportProgress += (100 / clsTotalRows)
            clsImportProgress = CInt(tmpImportProgress)
            RaiseEvent ImportProgress()
        End While

        clsImportedDataSet = myDataSet

    End Sub

End Class